# -*- perl -*-

#
# $Id: Satmap.pm,v 1.3 1998/08/01 21:05:19 eserte Exp $
# Author: Slaven Rezic
#
# Copyright (C) 1998 Slaven Rezic. All rights reserved.
# This package is free software; you can redistribute it and/or
# modify it under the same terms as Perl itself.
#
# Mail: eserte@cs.tu-berlin.de
# WWW:  http://user.cs.tu-berlin.de/~eserte/
#

package Karte::Satmap;

use Karte;

use strict;
use vars qw(@ISA $obj);

@ISA = qw(Karte Karte::Berlinmap1997);

sub new {
    my $class = shift;
    my $self =
      {
       Name     => 'Satellitenkarte von Berlin (JPEG)',
       Token    => 'satmap',
       Mimetype => 'image/jpeg',
       Coordsys => 'S',
       
       Fs_dir    => "/usr/www/berlin/satmap",
       Cache_dir => "$Karte::cache_root/satmap",
       Root_URL  => "http://www.kulturbox.de/stadtware/cities/b/pq/r195/1500",

       X0 => -12907.0725073228,
       X1 => 20.0037569198591,
       X2 => 0.436930297596207,
       Y0 => 30249.8007162269,
       Y1 => 0.389073964340719,
       Y2 => -20.0349350027507,

       Width  => 195,
       Height => 195,
      };
    bless $self, $class;
}

sub filename {
    my($self, $x, $y) = @_;
    sprintf("%s/s-$x/$y.%s", $self->fs_dir, $self->ext);
}

sub url {
    my($self, $x, $y) = @_;
    sprintf("%s/s-$x/$y.%s", $self->url, $self->ext);
}

$obj = new Karte::Satmap;

1;
