#!/usr/local/bin/perl5.004
#!/usr/perl5.00453/bin/perl
# -*- perl -*-

#
# $Id: bbbike.cgi,v 2.10 1998/08/01 21:11:49 eserte Exp $
# Author: Slaven Rezic
#
# Copyright (C) 1998 Slaven Rezic. All rights reserved.
# This program is free software; you can redistribute it and/or
# modify it under the same terms as Perl itself.
#
# Mail: eserte@cs.tu-berlin.de
# WWW:  http://user.cs.tu-berlin.de/~eserte/
#

use FindBin;
use lib ("/home/e/eserte/src/bbbike", "$FindBin::RealBin/..",
	 "$FindBin::RealBin/../lib");
use Strassen;
use CGI;
use CGI::Carp qw(fatalsToBrowser);
use strict;
use vars qw($VERSION
	    $tmp_fs $tmp_url $max_proc $use_miniserver);

# versucht, die C/XS-Version von make_net zu laden
eval q{local $SIG{'__DIE__'};
       use BBBikeXS;
   };

#(my $basename = $0) =~ s|^.*?([^/]+)$|$1|;

eval { local $SIG{'__DIE__'};
       do "$0.config" };
# CONFIG ###########################################################
# Konfigurationsvariablen mglichst in bbbike.cgi.config setzen!
if ($@) {
    # Mit ::OLD_AGREP = 1 wird das Verwenden von agrep verhindert
    # (stattdessen wird versucht, String::Approx zu verwenden).
    # agrep < 3.0 funktioniert nicht korrekt mit Umlauten.
    $Strassen::OLD_AGREP = 1;
    $PLZ::OLD_AGREP      = 1;
    $PLZ::OLD_AGREP      = $PLZ::OLD_AGREP; # peacify -w

    # im CS-Netz ist $ENV{PATH} beim Ausfhren als CGI-Skript leer
    $ENV{PATH} = '' if !defined $ENV{PATH};
    $ENV{PATH} = "/usr/bin:$ENV{PATH}"; # fr Sys::Hostname

    # XXX cachedir verwenden
    # URL fr Verzeichnis, in dem die temporren Imagemaps abgelegt werden
    $tmp_url = '/~eserte/tmp/bbbike';

    # ... dazugehriger Filesystem-Pfad
    $tmp_fs  = '/tmp/bbbike';

    # TRUE, wenn der Miniserver verwendet werden soll
    $use_miniserver = 0;

    # Miniserver: Anzahl der maximal gleichzeitig laufenden Prozesse
    $max_proc = 10;
}
####################################################################

if ($use_miniserver) {
    eval q{local $SIG{'__DIE__'};
	   require CGI::Base;
	   require CGI::Request;
	   require CGI::MiniSvr;
       };
    warn $@ if $@;
}

# beim ersten Mal *darf* kein HTTP-Response-Header bermittelt werden, 
# danach *mu* es geschehen
use vars qw($first_time);
$first_time = 1;

# header() patchen
package MyCGI;
use vars qw(@ISA);
@ISA = qw(CGI);
sub header {
    if (!$main::first_time && $main::use_miniserver) {
	print "HTTP/1.0 200 OK\n";
    }
    $main::first_time = 0;
    shift->SUPER::header(@_);
}

# damit ich weiterhin mit $q->... arbeiten kann
package MyRequest;
use vars qw(@ISA);
@ISA = qw(CGI::Request MyCGI);

package main;

$VERSION = sprintf("%d.%02d", q$Revision: 2.10 $ =~ /(\d+)\.(\d+)/);

my $font = 'helvetica,arial';
my $delim = '';
my $email    = 'eserte@cs.tu-berlin.de';
my $homepage = 'http://user.cs.tu-berlin.de/~eserte/';

unshift(@Strassen::datadirs,
	"/home/e/eserte/src/bbbike/data", "$FindBin::RealBin/../data");

my $q = new MyCGI;
my $str = new Strassen "strassen";

my $plz;
my $net;
my $multi_bez_str;
my $max = 25;
my %himmelsrichtung = ('n' => 'Nord',
		       'w' => 'West',
		       's' => 'Sd',
		       'e' => 'Ost',
		       'c' => 'Zentrum');

# Proze-Tabelle
my %proc;

# die originale URL (fr den Kaltstart)
my $bbbike_url = $q->url;
# $tmp_url absolut machen
$tmp_url = "http://" . $q->server_name . $tmp_url;
# Root-Verzeichnis von bbbike (fr die Bilder)
(my $bbbike_root = $bbbike_url) =~ s|[^/]*/[^/]*$||;
my $text_browser = $q->user_agent('lynx');

if (!-d $tmp_fs) {
    # unter der Voraussetzung, da /tmp schon existiert
    mkdir $tmp_fs, 0755;
}

my $bbbike_script = $q->url;

# den MiniSvr starten
my($cgi, $port);
if ($use_miniserver) {
    my $proc_slot = limit_processes();
    # zunchst noch mitloggen...
    CGI::Base::LogFile("/tmp/log");
    $cgi = new CGI::MiniSvr;
    $port = $cgi->port;
    $bbbike_script = "http://$ENV{SERVER_NAME}$port$ENV{SCRIPT_NAME}";
    choose_form();
    $cgi->done(0);
    $cgi->spawn and exit 0;
    # Prozenummer korrigieren
    set_process($proc_slot);
    CGI::Request::Interface($cgi);
}

# Request-Loop
while (1) {
    if ($use_miniserver) {
	$q = new MyRequest or $cgi->exit;
	$q->delete("~SequenceNumber ");    # strt nur...
    }

    if (defined $q->param('begin')) {
	$q->delete('begin');
	choose_form();
    } elsif (defined $q->param('info')) {
	$q->delete('info');
	show_info();
    } elsif (defined $q->param('all')) {
	choose_all_form();
    } elsif (defined $q->param('nahbereich')) {
	nahbereich();
    } elsif (defined $q->param('coords')) {
	draw_route();
    } elsif (defined $q->param('drawmap')) {
	draw_map();
    } elsif (defined $q->param('create_all_maps')) {
	foreach (qw(n e s w c)) {
	    $q->param('drawmap', $_);
	    draw_map();
	}
    } elsif (defined $q->param('startchar')) {
	choose_ch_form($q->param('startchar'), 'start');
    } elsif (defined $q->param('viachar')) {
	choose_ch_form($q->param('viachar'), 'via');
    } elsif (defined $q->param('zielchar')) {
	choose_ch_form($q->param('zielchar'), 'ziel');
    } elsif (defined $q->param('starti') and $q->param('starti') ne '' and
	     defined $q->param('zieli')  and $q->param('zieli') ne '') {
	search_index();
    } elsif (defined $q->param('startc') and
	     defined $q->param('zielc') and
	     defined $q->param('startname') and
	     defined $q->param('zielname')) {
	search_coord();
    } elsif (defined $q->param('startname') and $q->param('startname') ne ''
	     and 
	     defined $q->param('zielname')  and $q->param('zielname')  ne ''
	     and
	     via_not_needed()
	    ) {
	get_kreuzung();
    } else {
	choose_form();
    }

    if ($use_miniserver) {
	$cgi->done(0);
    } else {
	last;
    }
}

sub choose_street_html {
    my($strasse, $plz_number, $type) = @_;
    if (!$plz) {
	require PLZ;
	$plz = new PLZ;
    }
    my $plz_re = $plz->make_plz_re($plz_number);
    my @res = $plz->look($plz_re, Noquote => 1);
    my @strres = $str->union(\@res);
    if (!@strres) {
	print "Keine Straen im PLZ-Gebiet $plz_number.<br>\n";
	print ucfirst($type) . ": <input type=text name=$type><br>\n";
    } else {
	print <<EOF;
<b>$strasse</b> ist nicht in der BBBike-Datenbank erfat. Folgende Straen
sind im selben PLZ-Gebiet:<br>
EOF
        my @strname;
	for(my $i = 0; $i <= $#strres; $i++) {
	    push @strname, $str->get($strres[$i])->[0];
	    last if $i >= $max;
	}
	@strname = sort @strname;
	my $i = 0;
	my $strname;
	foreach $strname(@strname) {
	    print "<input type=radio name=" . $type . "name";
	    if ($i == 0) {
		print " checked";
	    }
	    print " value=\"$strname\">$strname<br>\n";
	    if ($i >= $max && $i < $#strres) {
		print "...<br>\n";
		last;
	    }
	    $i++;
	}
    }
}

sub choose_form () {
    my $startname = $q->param('startname') || '';
    my $start2    = $q->param('start2')    || '';
    my $start     = $q->param('start')     || '';
    my $vianame   = $q->param('vianame')   || '';
    my $via2      = $q->param('via2')      || '';
    my $via       = $q->param('via')       || '';
    my $zielname  = $q->param('zielname')  || '';
    my $ziel2     = $q->param('ziel2')     || '';
    my $ziel      = $q->param('ziel')      || '';

    foreach ([\$startname, \$start2, 'start'],
	     [\$vianame,   \$via2,   'via'],
	     [\$zielname,  \$ziel2,  'ziel']) {
	my $nameref = $_->[0];
	my $tworef  = $_->[1];
	my $type    = $_->[2];
	# berprfen, ob eine in PLZ vorhandene Strae auch in
	# Strassen vorhanden ist und ggfs. $....name setzen
	if ($$nameref eq '' && $$tworef ne '') {
	    my($strasse, $bezirk, $plz) = split(/$delim/o, $$tworef);
	    my $pos = $str->choose_street($strasse, $bezirk);
	    if (defined $pos) {
		$$nameref = $str->get($pos)->[0];
		$q->param($type . 'plz', $plz);
	    }
	}
    }

    # Es ist alles vorhanden, keine Notwendigkeit fr ein Formular.
  TRY: {
	if ($startname ne '' && $zielname ne '') {
	    last TRY if (((defined $via2 && $via2 ne '') ||
			  (defined $via  && $via  ne '')) &&
			 (!defined $vianame || $vianame eq ''));
	    get_kreuzung($startname, $vianame, $zielname);
	    return;
	}
    }

    my(@start_matches, @via_matches, @ziel_matches);
    foreach ([\$startname, \$start, \$start2, \@start_matches, 'start'],
	     [\$vianame,   \$via,   \$via2,   \@via_matches,   'via'],
	     [\$zielname,  \$ziel,  \$ziel2,  \@ziel_matches,  'ziel']) {
	my $nameref  = $_->[0];
	my $oneref   = $_->[1];
	# berprfen, ob eine Strae in PLZ vorhanden ist.
	if ($$nameref eq '' && $$oneref ne '') {
	    my $tworef   = $_->[2];
	    my $matchref = $_->[3];
	    my $type     = $_->[4];
	    if (!$plz) {
		require PLZ;
		$plz = new PLZ;
		if (!$plz) {
		    # Notbehelf. PLZ sollte mglichst installiert sein.
		    my @res = $str->agrep($$oneref);
		    if (@res) {
			$$nameref = $res[0];
		    }
		    last;
		}
	    }
	    @$matchref = $plz->look_loop($$oneref, Max => $max, Agrep => 3);
	    if (@$matchref > 1) {
	      TRY: {
		    my $first = $matchref->[0][0];
		    for(my $i = 1; $i <= $#$matchref; $i++) {
			if ($first ne $matchref->[$i][0]) {
			    last TRY;
			}
		    }
		    # alle Straennamen sind gleich
		    if (!$multi_bez_str) {
			$multi_bez_str = new MultiBezStr;
		    }
		    if ($multi_bez_str) {
			my %bezirk;
			foreach ($multi_bez_str->bezirke($first)) {
			    $bezirk{$_}++;
			}
			foreach (@$matchref) {
			    last TRY if !exists $bezirk{$_->[1]};
			}
			splice @$matchref, 1;
		    }
		}
	    }
	    if (@$matchref == 1) {
		my($strasse, $bezirk) = ($matchref->[0][0],
					 $matchref->[0][1]);
		my $pos = $str->choose_street($strasse, $bezirk);
		if (defined $pos) {
		    $$nameref = $str->get($pos)->[0];
		    $q->param($type . 'plz', $matchref->[0][2]);
		} else {
		    $$tworef = join($delim,
				    $matchref->[0][0],
				    $matchref->[0][1],
				    $matchref->[0][2]);
		}
	    }
	}
    }

    # Es ist alles vorhanden, keine Notwendigkeit fr ein Formular.
  TRY: {
	if ($startname ne '' && $zielname ne '') {
	    last TRY if (((defined $via2 && $via2 ne '') ||
			  (defined $via  && $via  ne '')) &&
			 (!defined $vianame || $vianame eq ''));
	    get_kreuzung($startname, $vianame, $zielname);
	    return;
	}
    }

    print $q->header(-expires => ($use_miniserver ? 'now' : '+1d'));
    my @extra_headers;
    if ($text_browser) {
	push @extra_headers, -up => $homepage;
    }
    header(@extra_headers);

    if ($start eq ''  && $ziel eq '' &&
	$start2 eq '' && $ziel2 eq '' &&
	$startname eq '' && $zielname eq '' &&
	!$q->param('smallform')) {
 	print <<EOF;
Dieses Programm sucht (Fahrrad-)Routen in Berlin. Es sind ca. 1600
Straen eingetragen (alle Hauptstraen und einige wichtige Nebenstraen).<p>
EOF
        if ($text_browser) {
            print <<EOF
<a name="navig"><a href="#start">Start-</a>, <a href="#via">Via- (optional)</a>
und <a href="#ziel">Zielstrae</a>
der Route auswhlen und dann <a href="#weiter">weiter</a></a>:<p>
EOF
        } else {
            print <<EOF
Start- und Zielstrae der Route auswhlen (Via ist optional): <p>
EOF
        }
    }

    my $has_windrose = 0;
    print "<form action=\"$bbbike_script\">\n";

    foreach ([\$startname, \$start, \$start2, \@start_matches, 'start'],
	     [\$vianame,   \$via,   \$via2,   \@via_matches,   'via'],
	     [\$zielname,  \$ziel,  \$ziel2,  \@ziel_matches,  'ziel']) {
	my $nameref   = $_->[0];
	my $oneref    = $_->[1];
	my $tworef    = $_->[2];
	my $matchref  = $_->[3];
	my $type      = $_->[4];

	my $printtype = ucfirst($type);
	my $tryempty  = 0;

	print "<a name=\"$type\"></a>";
	if ($$nameref ne '') {
	    print "<b>$printtype</b>: $$nameref\n";
	    print "<input type=hidden name=" . $type 
	      . "name value=\"$$nameref\">\n";
	    if (defined $q->param($type . "plz")) {
		print "<input type=hidden name=" . $type . "plz value=\"" 
		  . $q->param($type . "plz") . "\">\n";
	    }
	} elsif ($$oneref ne '' && @$matchref == 0) {
	    print "<b>$$oneref</b> ist nicht bekannt.<br>\n";
	    $tryempty = 1;
	} elsif ($$tworef ne '') {
	    my($strasse, $bezirk, $plz) = split(/$delim/o, $$tworef);
	    choose_street_html($strasse,
			       $plz,
			       $type);
	} elsif (@$matchref == 1) {
	    choose_street_html($matchref->[0][0],
			       $matchref->[0][2],
			       $type);
	} elsif (@$matchref > 1) {
	    print "Genaue <b>" . $printtype . "strae</b> auswhlen:\n";
	    my $s;
	    my $checked = 0;
	    print "<table>";
	    foreach $s (@$matchref) {
		my $strasse2val = join($delim, $s->[0], $s->[1], $s->[2]);
		print "<tr><td><input type=radio name=" . $type . "2 value=\"$strasse2val\"";
		if (!$checked) {
		    print " checked";
		    $checked++;
		}
		print "><td><font face=\"$font\">$s->[0]<td><font face=\"$font\" size=-1>$s->[1]<td><font face=\"$font\" size=-1>$s->[2]\n";
	    }
	    print "</table>";
	} else {
	    $tryempty = 1;
	}
	
	if ($tryempty) {
	    print "<b>$printtype</b>: ";
	    print "<input type=text name=$type> ";
	    if (!$q->param('smallform')) {
		my $myself = "http://" . $q->server_name;
		if (defined $port) {
		    $myself .= $port;
		}
		$myself .= $q->script_name . '?';
		if ($q->query_string ne '') {
		    $myself .= $q->query_string . '&';
		}
		for my $ch ('A' .. 'Z') {
		    print "<a href=\"" . $myself . $type
		      . "char=$ch\">$ch</a>";
		}
		print <<EOF;
<map name="wrmap_$type">
<area href="${myself}drawmap=c&type=$type" alt="$himmelsrichtung{'c'}"
      shape=poly coords="19,19,19,31,31,31,31,19,19,19"
      onMouseOver='return s("$printtype: $himmelsrichtung{'c'}")'>
<area href="${myself}drawmap=n&type=$type" alt="$himmelsrichtung{'n'}"
      shape=poly coords="19,19,31,19,31,0,19,0,19,19"
      onMouseOver='return s("$printtype: $himmelsrichtung{'n'}")'>
<area href="${myself}drawmap=s&type=$type" alt="$himmelsrichtung{'s'}"
      shape=poly coords="19,31,31,31,31,49,19,49,19,31"
      onMouseOver='return s("$printtype: $himmelsrichtung{'s'}")'>
<area href="${myself}drawmap=w&type=$type" alt="$himmelsrichtung{'w'}"
      shape=poly coords="19,19,0,19,0,31,19,31,19,19"
      onMouseOver='return s("$printtype: $himmelsrichtung{'w'}")'>
<area href="${myself}drawmap=e&type=$type" alt="$himmelsrichtung{'e'}"
      shape=poly coords="49,19,49,31,31,31,31,19,49,19"
      onMouseOver='return s("$printtype: $himmelsrichtung{'e'}")'>
</map>
<img alt="Karte" src="$bbbike_root/images/windrose2.gif" usemap="#wrmap_$type" align=middle border=0>
EOF
		$has_windrose++;
		print "<br>\n";
	    }
	}
	print "" . ($type eq 'ziel' ? "<p>" : '<hr>') . "\n";
    }

    if ($has_windrose) {
	print <<EOF;
<script language=javascript>
<!--
function s(text) {
  self.status=text;
  return true;
}
// -->
</script>
EOF
	print <<EOF;
Mit der Windrose kann man eine <b><u>groe</u></b> Imagemap zum Auswhlen einer Strae ffnen (ca. 350kB)<p>
EOF
    }

    hidden_smallform();
    print "<a name=\"weiter\"><input type=submit value=\"Weiter\"></a>";
    print "</form><hr>\n";
    if (!$q->param('smallform')) {
	print "<a href=\"$bbbike_script?all=1\">Liste aller bekannten Straen</a> (lang, ca. 180kB)<hr>\n";
    }
    footer();
    print $q->end_html;
}

sub choose_ch_form {
    my($search_char, $search_type) = @_;
    print $q->header(-expires => '+1d');
    header();
    print "<b>" . ucfirst($search_type) . "</b>";
    print " (Anfangsbuchstabe <b>$search_char</b>)<br>\n";
    my $next_char =
      (ord($search_char) < ord('Z') ? chr(ord($search_char)+1) : undef);
    my $prev_char =
      (ord($search_char) > ord('A') ? chr(ord($search_char)-1) : undef);
    print "<form action=\"$bbbike_script\">\n";
    print "<input type=submit value=\"Weiter\"><br>";
    foreach ($q->param) {
	unless ($_ eq 'startchar' || $_ eq 'viachar' || $_ eq 'zielchar' ||
		$_ eq $search_type) {
	    print "<input type=hidden name=$_ value=\""
	      . $q->param($_) . "\">\n";
	}
    }

    my @strlist;
    $str->init;
    eval q{ # eval wegen /o
	while(1) {
	    my $ret = $str->next;
	    last if !@{$ret->[1]};
	    my $name = $ret->[0];
	    push(@strlist, $name) if $name =~ /^$search_char/oi;
	}
    };
    @strlist = sort @strlist;

    print
      "<input type=radio name=" . $search_type . "name value=\"\"> ",
      "(nicht gesetzt)",
      "<br>\n";

    my $last_name;
    for(my $i = 0; $i <= $#strlist; $i++) {
	my $name = $strlist[$i];
	if (defined $last_name and $name eq $last_name) {
	    next;
	} else {
	    $last_name = $name;
	}
	print
	  "<input type=radio name=" . $search_type . "name value=\"$name\"> ",
	  $name,
	  "<br>\n";
    }

    print "<br>";
    print "<input type=submit value=\"Weiter\"><br>\n";
    if ($prev_char) {
	print "<input type=submit name=" . $search_type . "char value=\"$prev_char\">";
    }
    if ($next_char) {
	print "<input type=submit name=" . $search_type . "char value=\"$next_char\">";
    }
    print "</form>\n";
    footer();
    print $q->end_html;
}

sub choose_all_form {
    print $q->header(-expires => '+1d');
    header();

    my @strlist;
    $str->init;
    while(1) {
	my $ret = $str->next;
	last if !@{$ret->[1]};
	push(@strlist, $ret->[0]);
    }
    @strlist = sort @strlist;

    print "<form action=\"$bbbike_script\"><a name=\"top\"><input value=\"Weiter\" type=submit></a><br>";
    if ($text_browser) {
	foreach my $start_ziel ('start', 'ziel') {
	    print "<b>" . ($start_ziel =~ /start/i ? "Start" : "Ziel")
	      . ":</b><br>\n";
	    print "<select name=" . $start_ziel . "name>\n";
	    for(my $i = 0; $i <= $#strlist; $i++) {
		print
		  "<option>"
		    . $strlist[$i] . "</option>\n";
	    }	
	    print "</select>";
	    print "<p>\n";
	}
    } else {
	print "<center>";
	for my $ch ('A' .. 'Z') {
	    print "<a href=\"#$ch\">$ch</a>";
	}
	print "<br>\n";
	print "<hr>Start --- Strae --- Ziel<br>\n";
	my $last_ch = '';
	my $last_name;
	for(my $i = 0; $i <= $#strlist; $i++) {
	    my $name = $strlist[$i];
	    if (defined $last_name and $name eq $last_name) {
		next;
	    } else {
		$last_name = $name;
	    }
	    my $this_ch = substr($name, 0, 1);
	    if ($last_ch ne $this_ch) {
		print "<a name=\"\u$this_ch\"><hr><a href=\"#top\">zum Anfang</a><br>\n";
		$last_ch = $this_ch;
	    }
	    print
	      "<input type=radio name=startname value=\"$name\"> ",
	      $name,
	      "<input type=radio name=zielname value=\"$name\"> ",
	      "<br>\n";
	}
	print "</center>";
    }
    
    print <<EOF;
<input value="Weiter" type=submit>
</form>
EOF
    footer();
    print $q->end_html;
}

sub get_kreuzung {
    my($start_str, $via_str, $ziel_str) = @_;
    if (!defined $start_str) {
	$start_str = $q->param('startname');
    }
    if (!defined $via_str) {
	$via_str = $q->param('vianame');
    }
    if (!defined $ziel_str) {
	$ziel_str  = $q->param('zielname');
    }
    my $start_plz = $q->param('startplz');
    my $via_plz   = $q->param('viaplz');
    my $ziel_plz  = $q->param('zielplz');

    my($start, $via, $ziel);
    my(@start_coords, @via_coords, @ziel_coords);

    print $q->header(-expires => '+1d');
    header();
    print "Genaue Kreuzung angeben:<p>\n";

    $str->init;
    # XXX Abbruch knnte etwas frher erfolgen, und zwar bei
    # definiertem ziel und start und nchste Strae ist weder start
    # noch ziel 
    while(1) {
	my $ret = $str->next;
	last if !@{$ret->[1]};
	my $name = $ret->[0];
	if ($start_str eq $name) {
	    $start   = $str->pos;
	    push @start_coords, @{$ret->[1]};
	}
	if (defined $via_str && $via_str eq $name) {
	    $via     = $str->pos;
	    push @via_coords, @{$ret->[1]};
	}
	if ($ziel_str  eq $name) {
	    $ziel   = $str->pos;
	    push @ziel_coords, @{$ret->[1]};
	}
    }

    if (!defined $start || !defined $ziel) {
	die "Start und/oder Ziel knnen nicht zugeordnet werden.\n";
    }
    my(%crossings) = $str->all_crossings(RetType => 'hash',
					 UseCache => 1);

    print "<form action=\"$bbbike_script\">";
    foreach ([$start_str, \@start_coords, $start_plz, 'start'],
	     [$via_str,   \@via_coords,   $via_plz,   'via'],
	     [$ziel_str,  \@ziel_coords,  $ziel_plz,  'ziel'],
	    ) {
	my $str       = $_->[0];
	my @coords    = @{$_->[1]};
	next if !@coords; # kann bei nicht definiertem Via vorkommen
	my $plz       = $_->[2];
	my $type      = $_->[3];
	my $printtype = ucfirst($type);
	print "<b>$printtype</b>: " . stadtplan_link($str, $plz) 
	  . " Ecke ...<br>\n";
	print "<input type=hidden name=" . $type . "name value=\"$str\">";
	if (defined $q->param($type . "plz")) {
	    print "<input type=hidden name=" . $type . "plz value=\"" .
	      $q->param($type . "plz") . "\">\n";
	}
	my $i = 0;
	my %used;
	foreach (@coords) {
	    if ($used{$_}) {
		next;
	    } else {
		$used{$_}++;
	    }
	    if (exists $crossings{$_}) {
		print "<input type=radio name=" . $type . "c value=\"$_\"";
		if ($i++ == 0) {
		    print " checked";
		}
		print "> ";
		my @kreuzung;
		foreach (@{$crossings{$_}}) {
		    if ($_ ne $str) {
			push(@kreuzung, $_);
		    }
		}
		if (@kreuzung == 0) {
		    print "..."; # XXX bessere Loesung?
		} else {
		    print join("/", @kreuzung);
		}
		print "<br>\n";
	    }
	}
	print "" . ($type ne 'ziel' ? '<hr>' : '<br>') . "\n";
    }
    hidden_smallform();
    suche_button();
    print "<input type=submit name=nahbereich value=\"Nahbereich\">\n";
    print "</form>";
    footer();
    print $q->end_html;
}

sub nahbereich {
    my($startc, $zielc, $startname, $zielname) =
      ($q->param('startc'), $q->param('zielc'),
       $q->param('startname'),$q->param('zielname'));
    print $q->header(-expires => '+1d');
    header();
    print "Kreuzung im Nahbereich angeben:<p>\n";
    my(%crossings) = $str->all_crossings(RetType => 'hash',
					 UseCache => 1);
    my $kr = new Kreuzungen Hash => \%crossings;
    $kr->make_grid;
    my($startx, $starty) = split(/,/, $startc);
    my($zielx,  $ziely)  = split(/,/, $zielc);
    print "<form action=\"$bbbike_script\">";
    print "<b>Start</b>:<br>\n";
    print "<input type=hidden name=startname value=\"$startname\">";
    my $i = 0;
    foreach ($kr->nearest($startx, $starty)) {
	print "<input type=radio name=startc value=\"$_\"";
	if ($i++ == 0) {
	    print " checked";
	}
	print "> ", join("/", @{$crossings{$_}}), "<br>\n";
    }
    print "<hr>";
    print "<input type=hidden name=zielname value=\"$zielname\">";
    print "<b>Ziel</b>:<br>\n";
    $i = 0;
    foreach ($kr->nearest($zielx, $ziely)) {
	print "<input type=radio name=zielc value=\"$_\"";
	if ($i++ == 0) {
	    print " checked";
	}
	print "> ", join("/", @{$crossings{$_}}), "<br>\n";
    }
    print "<hr>";
    suche_button();
    print "</form>";
    footer();
    print $q->end_html;
}

sub suche_button {
# XXX
#    print "<input type=checkbox name=ampeln> Ampel-Optimierung<br>\n";
    print "<input type=submit value=\"Suche starten\">\n";
}

sub hidden_smallform {
    if ($q->param('smallform')) {
	print "<input type=hidden name=smallform value=\"" .
	  $q->param('smallform') . "\">\n";
    }
}

sub via_not_needed {
    my($via, $via2, $vianame) = @_;
    $via     = $q->param('via')     if !defined $via;
    $via2    = $q->param('via2')    if !defined $via2;
    $vianame = $q->param('vianame') if !defined $vianame;

    !(((defined $via2 && $via2 ne '') ||
       (defined $via  && $via  ne '')) &&
      (!defined $vianame || $vianame eq ''));
}

# wird nicht mehr untersttzt
sub search_index {
    my($start, $ziel) = ($q->param('starti'), $q->param('zieli'));

    my $start_o = $str->get_obj($start);
    if (!$start_o) {
	die "Startort $start nicht existent";
    }
    my $ziel_o = $str->get_obj($ziel);
    if (!$ziel_o) {
	die "Zielort $ziel nicht existent";
    }
    search_coord($start_o->coord_as_string(0), $ziel_o->coord_as_string(0),
		 $start_o->name, $ziel_o->name);
}

sub search_coord {
    my $startcoord  = $q->param('startc');
    my $viacoord    = $q->param('viac');
    my $zielcoord   = $q->param('zielc');
    my $startname   = $q->param('startname');
    my $vianame     = $q->param('vianame');
    my $zielname    = $q->param('zielname');
    my $alternative = $q->param('alternative');

    if (!$net) {
	$net = new StrassenNetz $str;
	$net->make_net;
	$net->make_sperre('gesperrt', Type => ['einbahn', 'sperre', 'tragen']);
    }

    my @r;
    my $via_array = (defined $viacoord && $viacoord ne ''
		     ? [$viacoord]
		     : []);

    if ($q->param('ampeln')) {
	my %ampeln;
	my $lsa = new Strassen "ampeln";
	$lsa->init;
	while(1){
	    my $ret = $lsa->next;
	    last if !@{$ret->[1]};
	    my($x,$y) = @{Strassen->to_koord1($ret->[1][0])};
	    $ampeln{$x}->{$y}++;
	}
	push @r, $net->search_via_obj($startcoord, $zielcoord, $via_array,
				      Ampeln => \%ampeln,
				      AmpelnPenalty => 100);
    } else {
	@r = $net->search_via_obj_all($startcoord, $zielcoord, $via_array);
    }

    print $q->header(-expires => '+1M');
    header();
    if (!@r) {
	print "Keine Route gefunden.\n";
    } else {
	my $r;
	if (defined $alternative &&
	    $alternative >= 0 && $alternative <= $#r) {
	    $r = $r[$alternative];
	} else {
	    $r = $r[0];
	}
	my(@strnames) = $net->route_to_name($r->path);
	print "<center><table bgcolor=\"#ffcc66\"><tr><td><font face=\"$font\">Route von <b>" . stadtplan_link($startname, $q->param('startplz')) . "</b> ";
	if (defined $vianame && $vianame ne '') {
	    print "ber <b>" . stadtplan_link($vianame, $q->param('viaplz'))
	      . "</b> ";
	}
	print "bis <b>" . stadtplan_link($zielname, $q->param('zielplz')) 
	  . "</b></table><br>\n";
	print "<table>\n";
	printf "<tr><td><font face=\"$font\">Lnge:<td><font face=\"$font\">%.2f km\n", $r->len/1000;
	print
	  "<tr><td><font face=\"$font\">Fahrzeit:<td><font face=\"$font\">",
	  make_time($r->len/1000/15) . "h (bei 15km/h), ",
	  make_time($r->len/1000/20) . "h (bei 20km/h), ",
	  make_time($r->len/1000/25) . "h (bei 25km/h)\n";
	print "</table>\n";
	if (defined $r->ampeln) {
	    print $r->ampeln . " Ampeln auf der Strecke.<br>\n";
	}
	print "<hr>";
	my($next_entf, $ges_entf_s, $next_winkel, $next_richtung);
	if ($text_browser) {
	    print "<pre>";
	    ($next_entf, $ges_entf_s, $next_winkel, $next_richtung)
	      = ("", "", undef, "");
	} else {
	    print "<table width=\"90%\" align=center bgcolor=\"#ffcc66\"><tr><th><font face=\"$font\">Etappe<th><font face=\"$font\">Richtung<th><font face=\"$font\">Strae<th><font face=\"$font\">Gesamt\n";
	    ($next_entf, $ges_entf_s, $next_winkel, $next_richtung)
	      = ("&nbsp;", "&nbsp;", undef, "&nbsp;");
	}
	my $ges_entf = 0;
	for(my $i = 0; $i <= $#strnames; $i++) {
	    my $str;
	    my($entf, $winkel, $richtung)
	      = ($next_entf, $next_winkel, $next_richtung);
	    ($str, $next_entf, $next_winkel, $next_richtung)
	      = @{$strnames[$i]};
	    if ($i > 0) {
		if (!$winkel) { $winkel = 0 }
		$winkel = int($winkel/10)*10;
		if ($winkel < 30) {
		    # ein Space, damit bgcolor ausgefllt wird
		    $richtung = ($text_browser ? "" : "&nbsp;");
		} else {
		    $richtung = 
		      ($winkel <= 45 ? 'halb' : '') . 
			($richtung eq 'l' ? 'links ' : 'rechts ') .
			  "($winkel) " . Strasse::de_artikel($str);
		}
		$ges_entf += $entf;
		$ges_entf_s = sprintf "%.1f km", $ges_entf/1000;
		$entf = sprintf "nach %.2f km", $entf/1000;
	    }
	    if ($text_browser) {
		printf "%-13s %-24s %-31s %-8s\n",
		$entf, $richtung, string_kuerzen($str, 31), $ges_entf_s;
	    } else {
		print "<tr><td><font face=\"$font\">$entf<td><font face=\"$font\">$richtung<td><font face=\"$font\">$str<td><font face=\"$font\">$ges_entf_s\n";
	    }
	}
	$ges_entf_s = sprintf "%.1f km", ($ges_entf+$next_entf)/1000;
	my $entf = sprintf "nach %.2f km", $next_entf/1000;
	if ($text_browser) {
	    printf "%-13s %-24s %-31s %-8s\n",
	    $entf, "angekommen!", "", $ges_entf_s;
	    print "</pre>\n";
	} else {
	    print
	      "<tr><td><font face=\"$font\">$entf<td><font face=\"$font\">angekommen!<td>&nbsp;<td><font face=\"$font\">$ges_entf_s\n";
	    print "</table>\n";
	}
	print "</center>\n";

	my $string_rep = $r->as_string;
	print "<hr>";
	print "<form method=post target=\"_blank\" action=\"$bbbike_script\">\n";
	print "<input type=submit value=\"Grafik zeichnen\"> <font size=-1>(neues Fenster wird geffnet)</font><br>";
	print "<input type=hidden name=coords value=\"$string_rep\">";
	print "<input type=hidden name=startname value=\"$startname\">";
	print "<input type=hidden name=zielname value=\"$zielname\">";
	print "<table><tr><td><font face=\"$font\"><b>Bildgre:\n";
	foreach my $geom ("400x300", "640x480", "800x600", "1024x768") {
	    print
	      "<td><input type=radio name=geometry value=\"$geom\"",
	      ($geom eq '640x480' ? " checked" : ""),
	      "><font face=\"$font\"> $geom  \n";
	}
	print "<tr><td><font face=\"$font\"><b>Details:";
	foreach my $draw (['Straen',  'str',    1],
			  ['S-Bahn',   'sbahn',  0],
			  ['U-Bahn',   'ubahn',  0],
			  ['Gewsser', 'wasser', 0],
			  ['Titel',    'title', 1],
			 ) {
	    print
	      "<td><input type=checkbox name=draw value=$draw->[1]",
	      ($draw->[2] ? " checked" : ""),
	      "><font face=\"$font\"> $draw->[0]  \n";
	}
	print "</table>\n";
	print "<p>";
	print <<EOF;
<font size=-1>Die Dateigre der Grafik betrgt je nach Bildgre und
Detailreichtum 15 bis 50 kB.</font><br>
EOF
	print "</form>\n";
	print "<hr><form action=\"$bbbike_script\">\n";
	print "<input type=hidden name=startc value=\"$zielcoord\">";
	print "<input type=hidden name=zielc value=\"$startcoord\">";
	print "<input type=hidden name=startname value=\"$zielname\">";
	print "<input type=hidden name=zielname value=\"$startname\">";
	if (defined $viacoord && $viacoord ne '') {
	    print "<input type=hidden name=viac value=\"$viacoord\">";
	    print "<input type=hidden name=vianame value=\"$vianame\">";
	}
	print "<input type=submit value=\"Rckweg\">";
	hidden_smallform();
	print "</form><hr>\n";

	# Andere Alternativen
	if (@r > 1) {
	    eval {
		local $SIG{'__DIE__'};
		require URI::Escape;
		my $i;
		print "Weitere Alternativen:<br><ul>\n";
		for($i = 0; $i <= $#r; $i++) {
		    print "<li>";
		    my $len = sprintf "%.2f km", $r[$i]->len;
		    if ((defined $alternative  && $i == $alternative) ||
			(!defined $alternative && $i == 0)) {
			print "diese Strecke ($len)";
		    } else {
			print
			  "<a href=\"$bbbike_script?",
			  "startc=" . URI::Escape::uri_escape($startcoord) . "&",
			  "startname=" . URI::Escape::uri_escape($startname) . "&",
			  "viac=" . URI::Escape::uri_escape($viacoord) . "&",
			  "vianame=" . URI::Escape::uri_escape($vianame) . "&",
			  "zielc=" . URI::Escape::uri_escape($zielcoord). "&",
			  "zielname=" . URI::Escape::uri_escape($zielname) . "&",
			  "alternative=" . URI::Escape::uri_escape($i),
			  "\">Alternative $i ($len)</a>";
		    }
		    print "\n";
		}
		print "</ul>\n";
	    };
	    warn $@ if $@;
	}
    }
    footer();
    print $q->end_html;
}

sub stadtplan_link {
    my($str, $plz) = @_;
    my $stadtplan_url = "http://www.kulturbox.de/cgi-bin/berlininfo";
# XXX nachgucke...
#    my $stadtplan_url = "http://www.stadtplandienst.de/";
    (my $str_plain = $str) =~ s/\s+\(.*\)$//;
    eval { local $SIG{'__DIE__'};
	   require URI::Escape;
       };
    if ($@) {
	$str;
    } else {
	$str_plain = URI::Escape::uri_escape($str_plain);
	"<a target=\"_blank\" href=\"$stadtplan_url?name=$str_plain" . 
	  (defined $plz ? "&plz=$plz" : "") . "\">$str</a>";
    }
# XXX nach der Einfhrung des neuen StadtINFO:
#    "<a target=\"stadtinfo\" href=\"$stadtplan_url?STR=$str_plain" . 
#      (defined $plz ? "&PLZ=$plz" : "") . "\">$str</a>;
}

sub string_kuerzen {
    my($str, $len) = @_;
    if (length($str) <= $len) {
	$str;
    } else {
	substr($str, 0, $len-3)."...";
    }
}

sub draw_route {
    eval {
	local $SIG{'__DIE__'};
	require BBBikeDraw;
    };
    if ($@) {
	print $q->header(-type => 'text/plain'), "Fehler: $@";
	exit 0;
    }

    print $q->header(-type => 'image/gif',
		     #-expires => 'now',
		     #-pragma => 'no-cache',
		    );
    my $draw = new_from_cgi BBBikeDraw $q;
    eval { $draw->dimension_from_route() };
    return if $@;
    $draw->create_transpose();
    $draw->draw_map();
    $draw->draw_route();
    $draw->flush();
}

sub draw_map {
    my(@dim);

    print $q->header();

    my $part = $q->param('drawmap') || '';
    if ($part eq 'n') {
	@dim = (-4600, 19600, 12625, 27925);
    } elsif ($part eq 's') {
	@dim = (-4600, 19600, -2775, 12600);
    } elsif ($part eq 'w') {
	@dim = (-9200, 1600, -650, 21775);
    } elsif ($part eq 'e') {
	@dim = (11675, 32525, -1975, 23325);
    } else {
	@dim = (1412, 13550, 7300, 14950);
	$part = 'c';
    }

    my $img_file = "$tmp_fs/berlin_map_$part.gif";
    my $img_url  = "$tmp_url/berlin_map_$part.gif";
    my $map_file = "$tmp_fs/berlin_map_$part.map";
    my $map_url  = "$tmp_url//berlin_map_$part.map";

    my $create = 1;
    my(@img_file_stat)   = stat($img_file);
    if (defined $img_file_stat[9]) {
	my(@map_file_stat)   = stat($img_file);
	if (defined $map_file_stat[9]) {
	    my(@bbbike_cgi_stat) = stat($0);
	    my(@strassen_stat)   = stat($str->{File});
	    my $to_create_time = min($img_file_stat[9], $map_file_stat[9]);
	    my $check_time     = max($bbbike_cgi_stat[9], $strassen_stat[9]);
	    $create = ($to_create_time < $check_time);
	}
    }
    if ($create || !-r $img_file || !-r $map_file) {
	eval {
	    local $SIG{'__DIE__'};
	    require BBBikeDraw;
	    open(IMG, ">$img_file")
	      or die "Die Karte $img_file konnte nicht erstellt werden.\n";
	    chmod 0644, $img_file;
	    open(MAP, ">$map_file")
	      or die "Die Map $map_file konnte nicht erstellt werden.\n";
	    chmod 0644, $map_file;
	    $q->param('geometry', "800x600");
	    $q->param('draw', 'str', 'ubahn', 'sbahn', 'wasser');
	    my $draw = new_from_cgi BBBikeDraw($q, \*IMG);
	    $draw->set_dimension(@dim);
	    $draw->create_transpose();
	    $draw->draw_map();
	    $draw->make_imagemap(\*MAP);
	    $draw->flush();
	    $q->delete('draw');
	    $q->delete('geometry');
	    close MAP;
	    close IMG;
	};
	warn $@ if $@;
    }

    require URI::Escape;

    my $url = $bbbike_script;
    $url .= "?";
    my $type = $q->param('type');
    foreach ($q->param) {
	unless ($_ eq 'drawmap' || $_ eq 'type') {
	    $url .= "$_=" . URI::Escape::uri_escape($q->param($_)) . "&";
	}
    }
    my $url_navig = $url . "type=$type&drawmap=";
    my $url_go    = $url . $type . "name="; # aufgefllt wird in der Map

    header();
    print "<center>";
    my %navig = ('c' => [qw(n w s e)],
		 'n' => [undef, 'w', 'c', 'e'],
		 'w' => ['n', undef, 's', 'c'],
		 's' => ['c', 'w', undef, 'e'],
		 'e' => ['n', 'c', 's', undef]
		);

    if (defined $navig{$part}->[0]) {
	print "<a href=\"" . $url_navig . $navig{$part}->[0] 
	  . "\">" . $himmelsrichtung{$navig{$part}->[0]} . "</a><br>\n";
    }
    print "<nobr>";
    if (defined $navig{$part}->[1]) {
	print "<a href=\"" . $url_navig . $navig{$part}->[1] 
	  . "\">" . $himmelsrichtung{$navig{$part}->[1]} . "</a>\n";
    }
    print "<img src=\"$img_url\" usemap=\"#map\" align=middle>\n";
    if (defined $navig{$part}->[3]) {
	print "<a href=\"" . $url_navig . $navig{$part}->[3] 
	  . "\">" . $himmelsrichtung{$navig{$part}->[3]} . "</a>";
    }
    print "</nobr><br>\n";
    if (defined $navig{$part}->[2]) {
	print "<a href=\"" . $url_navig . $navig{$part}->[2] 
	  . "\">" . $himmelsrichtung{$navig{$part}->[2]} . "</a><br>\n";
    }
    print "</center>";
    open(MAP, $map_file)
      or die "Die Map $map_file konnte nicht geladen werden.\n";
    while(<MAP>) {
	s/(href=\")/$1$url_go/;
	print $_;
    }
    close MAP;
    footer();
    print $q->end_html;
}

sub min {
    my $min;
    foreach (@_) {
	if (!defined $min || $_ < $min) { $min = $_ }
    }
    $min;
}

sub max {
    my $max;
    foreach (@_) {
	if (!defined $max || $_ > $max) { $max = $_ }
    }
    $max;
}

sub make_time {
    my($h_dec) = @_;
    my $h = int($h_dec);
    my $m = int(($h_dec-$h)*60);
    sprintf "%d:%02d", $h, $m;
}

sub limit_processes {
    dbmopen(%proc, "$tmp_fs/bbbike-limit", 0640);
    my $i;
  TRY: while(1) {
	for ($i = 0; $i < $max_proc; $i++) {
	    if (defined $proc{$i} && $proc{$i} ne '') {
		next if kill 0, $proc{$i};
	    }
	    $proc{$i} = $$;
	    last TRY;
	}
	print $q->header(-expires => 'now',
			 -pragma => 'no-cache');
	header();
	print <<EOF;
<center>
Der Rechner ist berlastet. Bitte ein paar Minuten spter versuchen!<p>
<small>Anzahl der erlaubten Prozesse: $max_proc</small>
</center><p>
EOF
        footer();
	print $q->end_html;
	exit;
    }
    dbmclose(%proc);
    $i;
}

sub set_process {
    my $slot = shift;
    dbmopen(%proc, "$tmp_fs/bbbike-limit", 0640);
    $proc{$slot} = $$;
    dbmclose(%proc);
}

sub header {
    my(%args) = @_;
    if (!exists $args{-title}) {
	$args{-title} = "BBBike";
    }
    if ($text_browser) {
	$args{-head} =
	  [CGI::link({-rel => 'Help',
		      -href => "$bbbike_script?info=1"}),
	   CGI::link({-rel => 'Start',
		      -href => "$bbbike_script?begin=1"}),
	   CGI::link({-rel => 'Up',
		      -href => ($args{-up} || "$bbbike_script?begin=1")}),
          ];
	if ($args{-contents}) {
	    push @{$args{-head}}, CGI::link({-rel => 'Contents',
					     -href => $args{'-contents'}});
	}
    }
    delete @args{qw(-contents -up)};
    print $q->start_html
      (%args,
       -BGCOLOR => '#ffffff',
       -meta=>{'keywords'=>'berlin fahrrad route bike karte suche',
	       'copyright'=>'(c) 1998 Slaven Rezic',
	      },
       -author => $email,
      );
    print "<font face=\"$font\">\n";
    print "<center><h1>$args{-title}";
    if (!$q->param('smallform')) {
	print "<img alt=\"\" src=\"$bbbike_root/images/srtbike.gif\" align=middle>";
    }
    print "</h1></center>\n";
}

sub footer {
# ?begin anscheinend notwendig (Bug in Netscape3, Solaris2?)
    my $smallform = ($q->param('smallform')
		     ? '&smallform=' . $q->param('smallform')
		     : '');
    print <<EOF;
<center>
<table bgcolor="#ffcc66" cellpadding=3>
<tr>
<td align=center><font face="$font">bbbike.cgi $VERSION
<td align=center><font face="$font">E-Mail: <a target="_top" href="mailto:$email?subject=BBBike">Slaven Rezic</a>
<td align=center><font face="$font"><a target="_top" href="$bbbike_script?begin=1$smallform">Neue Anfrage</a>
EOF
    if ($use_miniserver) {
        print <<EOF;
<td align=center><font face="$font"><a target="_top" href="$bbbike_url">Kaltstart</a>
EOF
    }
    print <<EOF;
<td align=center><font face="$font"><a target="_top" href="$bbbike_script?info=1$smallform">Info</a>
</table>
</center>
</font>
EOF
}

sub show_info {
    require Config;
    print $q->header(-expires => '+1d');
    header();
    my $cpan = "http://www.perl.com/CPAN/";
    print <<EOF;
<center><h2>Information</h2></center>
Das Programm versucht, den krzesten Weg zwischen den gewhlten Straen zu
finden. Da <b>agrep</b> bzw. <b>String::Approx</b> verwendet wird, mu man
den Straennamen nicht vllig korrekt eintippen. Gro- und Kleinschreibung
wird ignoriert.
<p>
Bei der Suche wird auf Einbahnstraen und zeitweilig gesperrte Straen
(Potsdamer Platz!) geachtet; auf Wind, Steigungen, Fahrbahnbeschaffenheit, 
Verkehrsdichte und Ampeln nicht --- vielleicht in einer spteren
Version <tt>:-)</tt><p>
EOF
    if ($use_miniserver) {
        print <<EOF;
Es gibt einen Timeout von $cgi->{'timeout'} Minuten pro Seite. Wenn
die Zeit abgelaufen ist, kann das Programm per "Kaltstart" neu
gestartet werden. Evtl. funktioniert das Programm nicht ber einen
Proxy; sollte es Probleme geben, eine <a
href="mailto:$email?subject=BBBike problems">E-Mail an mich</a>
schicken.<p>
EOF
    }

    # funktioniert nur auf dem CS-Server
    my $found_os = 0;
    if (open(INFO, "/usr/INFO/Rechnertabelle")) {
	my $host;
	eval q{local $SIG{'__DIE__'};
	       require Sys::Hostname;
	       $host = Sys::Hostname::hostname();
	   };
	while(<INFO>) {
	    if (/^$host:/o) {
		print "Hardware: " . (split /:/)[2] . "<p>\n";
		print "Betriebssystem: " . (split /:/)[3] . "<p>\n";
		$found_os++;
		last;
	    }
	}
	close INFO;
    }
    unless ($found_os) {
        print <<EOF;
Betriebssystem: \U$Config::Config{'osname'} $Config::Config{'osvers'}\E<p>
EOF
    }
    print <<EOF;
Verwendete Software:
<ul>
<li><a href="$cpan">perl $]</a>
<li>perl-Module:
<ul>
<li><a href="$cpan/modules/by-module/CGI/">CGI $CGI::VERSION</a>
<li><a href="$cpan/modules/by-module/CGI/">CGI::Base, CGI::Request, CGI::MiniSvr</a> bei der MiniServer-Version
<li><a href="$cpan/modules/by-module/GD/">GD</a> fr das Erzeugen der Grafik
<li><a href="$cpan/modules/by-module/Storable/">Storable</a>
<li><a href="$cpan/modules/by-module/String/">String::Approx</a> als agrep-Ersatz
<li><a href="$cpan/modules/by-module/URI/">URI::Escape, URI::URL</a>
</ul>
</ul>
<p>
<a href="http://pub.cs.tu-berlin.de/src/BBBike/">Verzeichnis</a>, in dem sich
die aktuellesten Sourcen des kompletten BBBike-Pakets
(mit perl/Tk-Interface) befindet.<p>
<a href="http://pub.cs.tu-berlin.de/gif/bbbike-screenshot.gif">Screenshot</a>
der perl/Tk-Version.
<p>
Die Zuordnung der Straen zu den Postleitzahlen stammt aus der STRADA-Datei
der Post.<p>
<a href="$homepage">Meine Homepage.</a><p>
EOF
    footer();
    print $q->end_html;
}

